# -*- coding: utf-8 -*-
"""task2.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1Z-Q4me-UXtWGG4PXuzqgiqnZFDSM6AEv

# Автоматическая обработка текстов

## Обработка текста в Python

### 1. Основные функции и методы
"""

a = 'The word you are looking for is "Hello".'
a

b = "I'll wait you there"
b

c = '''Тройные кавычки.
Для строк с переносами.
Русский язык поддерживается из коробки.
Как и любой другой'''
c

d = "And also" " you can " "split them in pieces"
d

"""- спецсимволы **\n** - перенос  **\t** - табуляция  **\r** - возврат каретки"""

a = "name\tsurname\nMickey\tMouse"
print(a)

# Строки можно сравнивать между собой
'a' < 'b' , 'test' < 'Hi'

# не всё так очевидно...
'ёжик' < 'медвежонок'

sorted('ёжикz8я/')

# смена регистра
hi = 'Всем привет!'
hi.upper(), hi.lower()

hi.title(), hi.swapcase()

# Поиск по строкам
tea = 'Съешь ещё этих мягких французских булок, да выпей же чаю!'
print(tea.count('е'))

print(tea.rfind('чаю')) ## or tea.find tea.rfind tea.rindex

tea[53:]

# предикаты
"Телевизор".endswith("визор")   # also : startswith

"16E45".isalnum(), "16".isdigit(), "test".islower(), "q".isalpha(), "Test Me".istitle()

# split и join 

a = "ID\tNAME\tSURNAME\tCITY\tREGION\tAGE\tWEALTH\tREGISTERED"
print(a)
print(a.split())
print('~'.join(a.split()))

# Выравнивание 
a = "Luke Skywalker"
print(a.ljust(40, '~'))
print(a.rjust(40, '~'))
print(a.center(40, '~'))

"""## 2. Библиотека NLTK

Библиотека NLTK, или NTLK – пакет библиотек и программ для символьной и статистической обработки естественного языка, написанных на языке программирования Python.
"""

import nltk

nltk.download() # нужно только после первой устанвки, чтобы скачать все состовляющие пакет базы вроде стоп-слов

#Загрузите тексты из коллекции book.
from nltk.book import *

#Для того чтобы использовать уже загруженные тексты достаточно указать их имена.
text1

text3

#Выведите на экран конкорданс (контекст) слова monstrous в text1.
text1.concordance('monstrous')

"""Конкорданс позволяет увидеть слово в контексте. Например, слово monstrous встречается в окружении таких слов как the ___ pictures и a ___ size. Какие еще слова встречаются в похожем наборе контекстов? """

text1.similar('monstrous')

text2.similar('monstrous')

"""*Коллокация* – это последовательность слов, которые часто употребляются вместе. Например, red wine (красное вино) – это коллокация, в то время как the wine  (это вино) – нет. Сочетание слов в коллокации является устойчивым. Если изменить одно из слов коллокации на синонимичное, то смысл теряется. Например, словосочетание  maroon wine (темно-бордовое вино) звучит очень странно и несет другое значение.
Для начала можно извлечь из текста все биграммы (bigrams) – пары слов.
 
Устойчивые, часто встречающиеся биграммы будут являться коллокациями. Для поиска коллокаций можно использовать специальную функцию.

"""

list(nltk.bigrams(['more','is','said','than','done']))

text4.collocations()
text5.collocations()

"""### Задание 1.

Найдите в Книге Бытия (The Book of Genesis) информацию о том, сколько лет прожили разные люди ("lived").
"""

text3.concordance('lived')

"""Использование common_contexts позволяет опередлить общий контекст двух или более слов."""

text2.common_contexts(["monstrous","very"])

"""Определите местоположение слова в тексте с помощью функции dispersion plot (участки дисперсии)."""

text4.dispersion_plot(["citizens", "democracy", ])

#Изучите команды, позволяющие получить информацию о словарном составе текста. Определите количество слов и знаков препинания в тексте (токенов, tokens).
len(text3)

"""### Задание 2. 
Какую информацию и тексте выводят следующие команды?
"""

# sorted(set(text3)) # отсортированный список слов в тексте
# len(set(text3)) # количество слов в тексте
# text3.count("smote") # сколько раз слово (smote) встречается в тексте 
# 100*text4.count("a") / len(text4) # процентное содержание буквы 'a' в тексте
# len(set(text3)) / len(text3) # отношение числа слов в тексте к числу символов в тексте

"""### Задание 3.

Чем отличаются следующие строчки? Значение которой из них будет больше? 
"""

sorted(set(w.lower() for w in text1)) # все слова в нижний регистр переводятся и из них уже создаётся список
# len(sorted(w.lower() for w in set(text1))) # регистр слов не учитывется (в списке сначала слова повторяются, оличаясь регистром, потом они все в нижний переводятся)

"""### Задание 4.
Напишите функцию vocab_size(text),  возвращающую объем словаря (все слова без учета регистра и без цифр, знаков препинания) текста text.
"""

import re

def vocab_size(text: Text):
  result = []
  for w in set(w.lower() for w in text):
    if w.isalpha:
      result.append(w)
  return len(result)

vocab_size(text1)



"""### Задание 5.
Напишите функцию percent(word, text), подсчитывающую как часто слово word встречается в тексте text и выражающую результат в процентах.
"""

def percent(word: str, text: Text):
  return text.count(word)/len(text) * 100

percent('a', text3)

"""### Задание 6.

6.1. Найдите все слова в тексте, длины которых превышает 15 символов и отсортируйте их.
 
6.2. Какие выводы можно сделать о полученных словах? Являются ли данные слова ключевыми в тексте?

"""

def find_all_word_len(text:Text, length: int):
  result = []
  for w in text:
    if len(w) > length:
      result.append(w)
  return result

find_all_word_len(text3, 15)

"""Определение 50 слов, наиболее часто встречающихся в книге Moby Dick.
Функция FreqDist (frequency distribution – частотное распределение) определяет частоту встречаемости каждого элемента словаря в указанном тексте.
Вывести информацию о 50 самых часто встречающихся токенах в тексте можно с помощью команды most_common(50).
"""

from nltk import FreqDist

fdist1 = FreqDist(text1)
fdist1.most_common(50)

"""### Задание 7.
3.1. Сколько всего токенов в тексте text1? Сколько среди них уникальных?

3.2. Что будет результатом выполнения команды fdist1["whale"]?
  
3.3. Обратите внимание на самые часто встречающиеся токены текста. К какой части речи они относятся? Какова их длина? Сделайте выводы.

3.4. Выведите информацию о накопительной частоте первых 50 самых часто встречающихся слов с помощью команды fdist1.plot(50, cumulative=True). 

![title](freq.png)
 
3.5. По графику посмотрите, каков процент первых 50 слов в общем количестве токенов данного текста.

3.6. Выведите на экран информацию о словах, которые встречаются в тексте всего один раз. Используйте команду fdist1.hapaxes().

3.7. Что общего у слов, которые встречаются в тексте всего один раз?

"""

# 3.1
len(text1) # всего
len(FreqDist(text1)) # кол-во уникальных

# 3.2
fdist1['whale'] # частоту слова

# 3.3
FreqDist(text1).most_common(50)

"""      Ознакомьтесь с основными функциями для вычисления частотного распределения, используемых в работе с nltk.
 
![title](freq2.png)
"""

# 3.4. Выведите информацию о накопительной частоте первых 50 самых часто встречающихся слов с помощью команды fdist1.plot(50, cumulative=True).
fdist1.plot(50, cumulative=True)

# 3.5. По графику посмотрите, каков процент первых 50 слов в общем количестве токенов данного текста.
most_list = FreqDist(text1).most_common(50)
print(f'Популярные слова: {most_list}')
most = 0
for word, count in most_list:
  most += count
print(f"Количество 50 популярных слов: {most}")
most/len(text1)

# 3.6. Выведите на экран информацию о словах, которые встречаются в тексте всего один раз. Используйте команду fdist1.hapaxes().
fdist1.hapaxes()
# 3.7. Что общего у слов, которые встречаются в тексте всего один раз? (написаны заглавными буквами)

"""### Задание 8.
Введите следующие команды. Выясните назначение каждой команды, поясните результаты работы команд применительно к исходному тексту.
"""

# [len(w) for w in text1] # длина каждого слова в тексте
# fdist=FreqDist(len(w) for w in text1) # частота слов для каждой из длин
# fdist.most_common # частота слов для каждой из длин в порядке уменьшения количества их в тексте
# fdist.max() # слов какой длины больше всего в тексте
# fdist[3] # количество слов длинной 3
# fdist.freq(3) # доля слов длинной 3 относительно других в тексте

"""### Задание 9.

Найдите все слова из четырех букв в тексте text5. С помощью функции частотного распределения (FreqDist) упорядочите их в порядке невозрастания по частоте.
"""

fdist=FreqDist(word for word in text5 if word.isalpha and len(word) == 4)
fdist